/*  File: kernel.cc
 *  Project: Deductor
 *  Created by Zoltán Nagy on 21/12/13.
 *  Modified DES 21 November 1014
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

/*   Deductor headers  */
#include <deductor.h>


/*   deductor and standard namespaces   */
using namespace duct;
using namespace std;


/*   I think this is the safest way, if we use C linking for the global variables.
 *   May be it is not necessary. I think global variables on the global namespace 
 *   has C linkage by default.
 */
extern "C" {
  
  /*   This is the main routine to create a kernel and save it to 
   *   file. So, we can use it later (refering to it by its name).
   *   Generating one kernel takes a lot of time (about an hour on an iMac).
   */
  std::function<void()> main_kern = [=]() -> void
  {
    /*  Creating the kernel. This basically defines the collider.
     *  The kernel name is "LHC-14TeV" and it is defined with our
     *  standard PDFs.
     */
    deductor<hhc> kernel_7TeV("LHC-7TeV", deductor_attr<hhc>(7.0_TeV));
  };
  
}



